﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace ReadySteadyBGArena
{
    public class ReadySteadyBGArena : HBPlugin
    {
        public override string Name { get { return "Ready Steady BGArena"; } }
        public override string Author { get { return "Rozman"; } }
        public override Version Version { get { return new Version(1, 3); } }
        public override bool WantButton { get { return true; } }
        private static readonly Stopwatch timerAccept = new Stopwatch();
        private bool AcceptTrigger = false;
        private int AcceptingTime = 0;

        public override void OnEnable()
        {
            Lua.Events.AttachEvent("UPDATE_BATTLEFIELD_STATUS", BGArena);
            Logging.Write("ReadySteadyBGArena - Loaded Version " + Version);
        }

        public override void OnDisable()
        {
            Lua.Events.DetachEvent("UPDATE_BATTLEFIELD_STATUS", BGArena);
            Logging.Write("ReadySteadyBGArena - Disabled");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public override void Pulse()
        {
			if (!StyxWoW.IsInGame) return;
            if (!AcceptTrigger) return;

            // TODO: use MAX_BATTLEFIELD_QUEUES
            for (int i = 1; i <= 3; i++) {
                List<string> BGStatus = Lua.GetReturnValues("return GetBattlefieldStatus(" + i + ")");

                if (BGStatus[0] == "confirm") {
                    Logging.Write("[ReadySteadyBGArena]: Yes, it's confirm window. Accepting between 4-25 seconds");

                    if (!timerAccept.IsRunning) timerAccept.Start();

                    if (timerAccept.ElapsedMilliseconds < AcceptingTime)
                    {
                        return;
                    }

                    Lua.DoString("AcceptBattlefieldPort("+i+",1)");
                    Lua.DoString("StaticPopup_Hide(\"CONFIRM_BATTLEFIELD_ENTRY\")");
                    break;
                }
            }

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

		public void BGArena(object sender, LuaEventArgs args)
		{
            Random r = new Random();

			AcceptTrigger = true;
			AcceptingTime = r.Next(4000, 25000);

			Logging.Write("[ReadySteadyBGArena]: BG/Arena status changed. I will go and look, it's CONFIRM window or not...");
		}

    }
}