﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace ReadySteadyCheck
{
    public class ReadySteadyCheck : HBPlugin
    {
        public override string Name { get { return "Ready Steady Check"; } }
        public override string Author { get { return "Rozman"; } }
        public override Version Version { get { return new Version(1, 3); } }
        public override bool WantButton { get { return true; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static readonly Stopwatch timerAccept = new Stopwatch();
        private bool AcceptTrigger = false;
        private int AcceptingTime = 0;

        public override void OnEnable()
        {
            Lua.Events.AttachEvent("READY_CHECK", Ready);
            Logging.Write("ReadySteadyCheck - Loaded Version " + Version);
        }

        public override void OnDisable()
        {
            Lua.Events.DetachEvent("READY_CHECK", Ready);
            Logging.Write("ReadySteadyCheck - Disabled");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public override void Pulse()
        {
			if (!StyxWoW.IsInGame) return;
            if (!AcceptTrigger) return;

			if (!timerAccept.IsRunning) timerAccept.Start();

			if (timerAccept.ElapsedMilliseconds < AcceptingTime)
			{
				return;
			}

            if (Me.IsDead || Me.IsGhost)
            {
                Logging.Write("Clicked NOT READY, because we are dead.");
                Lua.DoString("RunMacroText(\"/click ReadyCheckFrameNoButton\");");
            } else {
                Lua.DoString("RunMacroText(\"/click ReadyCheckFrameYesButton\");");
                Lua.DoString("/script ConfirmReadyCheck(1);");
            }

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public void Ready(object sender, LuaEventArgs args)
        {
            Random r = new Random();

			AcceptTrigger = true;
			AcceptingTime = r.Next(2000, 6000);

			Logging.Write("[ReadySteadyCheck]: Ready Check menu detected, clicking Ready between 2-6 seconds");
        }
    }
}