﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace ReadySteadyGo
{
    public class ReadySteadyGo : HBPlugin
    {
        public override string Name { get { return "Ready Steady Go"; } }
        public override string Author { get { return "Rozman"; } }
        public override Version Version { get { return new Version(1, 3); } }
        public override bool WantButton { get { return true; } }
        private static readonly Stopwatch timerAccept = new Stopwatch();
        private bool AcceptTrigger = false;
        private int AcceptingTime = 0;

        public override void Pulse()
        {
			if (!StyxWoW.IsInGame) return;
            if (!AcceptTrigger) return;

			if (!timerAccept.IsRunning) timerAccept.Start();

			if (timerAccept.ElapsedMilliseconds < AcceptingTime)
			{
				return;
			}

			Lua.DoString("AcceptProposal()");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public override void OnEnable()
        {
            Lua.Events.AttachEvent("LFG_PROPOSAL_SHOW", AcceptLFG);
            Logging.Write("ReadySteadyGo - Loaded Version " + Version);
        }

        public override void OnDisable()
        {
            Lua.Events.DetachEvent("LFG_PROPOSAL_SHOW", AcceptLFG);
            Logging.Write("ReadySteadyGo - Disabled");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

		public void AcceptLFG(object sender, LuaEventArgs args)
		{
            Random r = new Random();

			AcceptTrigger = true;
			AcceptingTime = r.Next(4000, 20000);

			Logging.Write("[ReadySteadyGo]: LFG menu detected, accepting between 4-20 seconds");
		}

    }
}