﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace ReadySteadyLive
{
    public class ReadySteadyLive : HBPlugin
    {
        public override string Name { get { return "Ready Steady Live"; } }
        public override string Author { get { return "Rozman"; } }
        public override Version Version { get { return new Version(1, 3); } }
        public override bool WantButton { get { return true; } }
        private static readonly Stopwatch timerAccept = new Stopwatch();
        private bool AcceptTrigger = false;
        private int AcceptingTime = 0;

        public override void OnEnable()
        {
            Lua.Events.AttachEvent("RESURRECT_REQUEST", AcceptRes);
            Logging.Write("ReadySteadyLive - Loaded Version " + Version);
        }

        public override void OnDisable()
        {
            Lua.Events.DetachEvent("RESURRECT_REQUEST", AcceptRes);
            Logging.Write("ReadySteadyLive - Disabled");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public override void Pulse()
        {
			if (!StyxWoW.IsInGame) return;
            if (!AcceptTrigger) return;

			if (!timerAccept.IsRunning) timerAccept.Start();

			if (timerAccept.ElapsedMilliseconds < AcceptingTime)
			{
				return;
			}

            Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\");");
            Lua.DoString("/script AcceptResurrect();");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

		public void AcceptRes(object sender, LuaEventArgs args)
		{
            Random r = new Random();

			AcceptTrigger = true;
			AcceptingTime = r.Next(3000, 6000);

            Logging.Write("[ReadySteadyLive]: Resurrect menu detected, accepting between 3-6 seconds");
		}
    }
}