﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace ReadySteadyRoleCheck
{
    public class ReadySteadyRoleCheck : HBPlugin
    {
        public override string Name { get { return "Ready Steady Role Check"; } }
        public override string Author { get { return "Rozman"; } }
        public override Version Version { get { return new Version(1, 3); } }
        public override bool WantButton { get { return true; } }
        private static readonly Stopwatch timerAccept = new Stopwatch();
        private bool AcceptTrigger = false;
        private int AcceptingTime = 0;

        public override void OnEnable()
        {
            Lua.Events.AttachEvent("LFG_ROLE_CHECK_SHOW", RoleCheck);
            Logging.Write("ReadySteadyRoleCheck - Loaded Version " + Version);
        }

        public override void OnDisable()
        {
            Lua.Events.DetachEvent("LFG_ROLE_CHECK_SHOW", RoleCheck);
            Logging.Write("ReadySteadyRoleCheck - Disabled");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public override void Pulse()
        {
			if (!StyxWoW.IsInGame) return;
            if (!AcceptTrigger) return;

			if (!timerAccept.IsRunning) timerAccept.Start();

			if (timerAccept.ElapsedMilliseconds < AcceptingTime)
			{
				return;
			}

            if (Styx.StyxWoW.Me.SpecType == SpecType.Healer)
            {
                Lua.DoString("/run UnitSetRole(\"player\",\"HEALER\")");
                Lua.DoString("/script UnitSetRole(\"player\",\"HEALER\")");
                Logging.Write("[ReadySteadyRoleCheck]: checked role as HEALER");
            }
            else if (Styx.StyxWoW.Me.SpecType == SpecType.RangedDps || Styx.StyxWoW.Me.SpecType == SpecType.MeleeDps)
            {
                Lua.DoString("/run UnitSetRole(\"player\",\"DAMAGER\")");
                Lua.DoString("/script UnitSetRole(\"player\",\"DAMAGER\")");
                Logging.Write("[ReadySteadyRoleCheck]: checked role as DAMAGER");
            }
            else if (Styx.StyxWoW.Me.SpecType == SpecType.Tank)
            {
                Lua.DoString("/run UnitSetRole(\"player\",\"TANK\")");
                Lua.DoString("/script UnitSetRole(\"player\",\"TANK\")");
                Logging.Write("[ReadySteadyRoleCheck]: checked role as TANK");

            }

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptTrigger = false;
            AcceptingTime = 0;
        }

        public void RoleCheck(object sender, LuaEventArgs args)
        {
            Random r = new Random();

			AcceptTrigger = true;
			AcceptingTime = r.Next(4000, 8000);

            Logging.Write("[ReadySteadyRoleCheck]: Role Check menu detected, clicking Ready between 4-8 seconds");
        }

    }
}